---
title: SourceBuffer.mode
slug: Web/API/SourceBuffer/mode
tags:
  - API
  - Audio
  - Experimental
  - MSE
  - Media Source Extensions
  - Property
  - Reference
  - SourceBuffer
  - Video
  - mode
---
<div>{{APIRef("Media Source Extensions")}}{{SeeCompatTable}}</div>

<p>The <code><strong>mode</strong></code> property of the {{domxref("SourceBuffer")}} interface controls whether media segments can be appended to the <code>SourceBuffer</code> in any order, or in a strict sequence.</p>

<p>The two available values are:</p>

<ul>
 <li><code>segments</code>: The media segment timestamps determine the order in which the segments are played. The segments can be appended to the <code>SourceBuffer</code> in any order.</li>
 <li><code>sequence</code>: The order in which the segments are appended to the <code>SourceBuffer</code> determines the order in which they are played. Segment timestamps are generated automatically for the segments that observe this order.</li>
</ul>

<p>The mode value is initially set when the <code>SourceBuffer</code> is created using <code>MediaSource.addSourceBuffer()</code>. If timestamps already exist for the media segments, then the value will be set to <code>segments</code>; if they don't, then the value will be set to <code>sequence</code>.</p>

<p>If you try to set the <code>mode</code> property value to <code>segments</code> when the initial value is <code>sequence</code>, an exception will be thrown. The existing segment order must be maintained in <code>sequence</code> mode. You can, however, change the value from <code>segments</code> to <code>sequence</code>. It just means the play order will be fixed, and new timestamps generated to reflect this.</p>

<p>This property cannot be changed during while the <code>SourceBuffer</code> is processing either an {{domxref("SourceBuffer.appendBuffer","appendBuffer()")}} or {{domxref("SourceBuffer.remove","remove()")}} call.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">var <em>myMode</em> = <em>sourceBuffer</em>.mode;

<em>sourceBuffer</em>.mode = 'sequence';
</pre>

<h3 id="Value">Value</h3>

<p>A {{domxref("DOMString")}}.</p>

<h3 id="Exceptions">Exceptions</h3>

<p>The following exceptions may be thrown when setting a new value for this property.</p>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Exception</th>
   <th scope="col">Explanation</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><code>InvalidAccessError</code></td>
   <td>An attempt was made to set the value to <code>segments</code> when the initial value is <code>sequence</code>.</td>
  </tr>
  <tr>
   <td><code>InvalidStateError</code></td>
   <td>The {{domxref("SourceBuffer")}} object is being updated (i.e. its {{domxref("SourceBuffer.updating")}} property is currently <code>true</code>), the last media segment appended to this <code>SourceBuffer</code> is incomplete, or this <code>SourceBuffer</code> has been removed from the {{domxref("MediaSource")}}.</td>
  </tr>
 </tbody>
</table>

<h2 id="Example">Example</h2>

<p>This snippet sets the <code>sourceBuffer</code> mode to <code>'sequence'</code> if it is currently set to <code>'segments'</code>, thus setting the play order to the sequence in which media segments are appended.</p>

<pre class="brush: js notranslate">var curMode = sourceBuffer.mode;
if (curMode == 'segments') {
  sourceBuffer.mode = 'sequence';
}</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Media Source Extensions', '#idl-def-sourcebuffer-mode', 'mode')}}</td>
   <td>{{Spec2('Media Source Extensions')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.SourceBuffer.mode")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("MediaSource")}}</li>
 <li>{{domxref("SourceBufferList")}}</li>
</ul>
